//+------------------------------------------------------------------+
//|                                                       FPA3&4.mq4 |
//|                                                              DRM |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "DRM"
#property link      ""
#include <stdlib.mqh>
#define MAGICMA  20090720
int TimeFrame = PERIOD_M15;
int lots = 0.1;
//========================================================================================
// Initialize
//========================================================================================
int init()
{return(0);}
//========================================================================================
// Deinitialize
//========================================================================================
int deinit()
{return(0);}
//========================================================================================
// Get Price High Values
//========================================================================================
double getHH(int shift)
{double price = High[shift];
int indexofHH = ArrayMaximum(High, WHOLE_ARRAY, 1);
double HH = High[indexofHH];
return(HH);}
//========================================================================================
// Get Price Low Values
//========================================================================================
double getLL(int shift)
{double price = Low[shift];
int indexofLL = ArrayMaximum(Low, WHOLE_ARRAY, 1);
double LL = Low[indexofLL];
return(LL);}
//========================================================================================
// Get ADX values
//========================================================================================
double getADX(int shift)
{double ADX = iADX(NULL, TimeFrame, 14, PRICE_CLOSE, MODE_MAIN, shift); return(ADX);}
//========================================================================================
// Get SMA values
//========================================================================================
double getCSMA(int period, int shift)
{double CSMA = iMA(NULL, TimeFrame, period, 0, MODE_SMA, PRICE_CLOSE, shift);  return(CSMA);}
double getLSMA(int period, int shift)
{double LSMA = iMA(NULL, TimeFrame, period, 0, MODE_SMA, PRICE_LOW, shift); return(LSMA);}
double getHSMA(int period, int shift)
{double HSMA = iMA(NULL, TimeFrame, period, 0, MODE_SMA, PRICE_HIGH, shift); return(HSMA);}
//========================================================================================
// Check for Currently Open Positions
//========================================================================================
int OpenOrders()
  {
   int buys=0,sells=0;
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA)
        {
         if(OrderType()==OP_BUY)  buys++;
         if(OrderType()==OP_SELL) sells++;
        }
     }
int total = buys + sells;
return(total);}
//========================================================================================
// Run at Every Tick
//========================================================================================
void start()
{
 if(OpenOrders()==0) {double Curr40SMA = getCSMA(40, 1);
 double Prev40SMA = getCSMA(40, 6);
 double Curr3LSMA = getLSMA(3, 1);
 double Prev3LSMA = getLSMA(3, 6);
 double Curr3HSMA = getHSMA(3, 1);
 double Prev3HSMA = getHSMA(3, 6);
 double HH3 = getHH(3);
 double HH10 = getHH(10);
 double HH35 = getHH(35);
 double LL3 = getLL(3);
 double LL10 = getLL(10);
 double LL35 = getLL(35);
 double ADX1 = getADX(1);
 double ADX4 = getADX(4);
 double ADX7 = getADX(7);
 double ADX11 = getADX(11);
 double ADX14 = getADX(14);
 double TR1 = getHH(1) - getLL(1);
 double TR2 = getHH(2) - getLL(2);
 double TR3 = getHH(3) - getLL(3);
 double TR4 = getHH(4) - getLL(4);
 double TR5 = getHH(5) - getLL(5);
 double ATR = (TR1+TR2+TR3+TR4+TR5)/7;
 int new;
 if (Curr40SMA>Prev40SMA && Curr3LSMA<Prev3LSMA && LL10>LL35 && HH3<HH10 && (ADX1>16 || ADX4>16 || ADX7>16 || ADX11>16 || ADX14>16))
      {new=OrderSend(Symbol(), OP_BUYSTOP, lots, Ask, 4, 0, 0, "", MAGICMA, 2, Red); return;}
 if (Curr40SMA<Prev40SMA && Curr3HSMA>Prev3HSMA && HH10<HH35 && LL3>LL10 && (ADX1>16 || ADX4>16 || ADX7>16 || ADX11>16 || ADX14>16))
      {new=OrderSend(Symbol(), OP_SELLSTOP, lots, Bid, 4, 0, 0, "", MAGICMA, 2, Blue); return;}
 for(int cnt=0;cnt<OrdersTotal();cnt++) 
   {OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
   if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA)
      {if(OrderType()==OP_BUY)
         {if(Bid-OrderOpenPrice()==ATR) {OrderClose(OrderTicket(),OrderLots(),Bid,4,Violet); return(0);}}
       if(OrderType()==OP_SELL)
         {if(OrderOpenPrice()-Ask==ATR) {OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); return(0);}}
      }
   }
}
}